// vim:syntax=ragel

%%{
    machine JSON_array;
    alphtype int;
    write data;

    action parse_value {
	state->level++;
	i = _parse_JSON(fpc, pe, state);
	state->level--;

	if (i == NULL) {
	    if (!state->validate) { 
#ifdef ARRAY_USES_STACK
		if (c > 0) stack_pop_n_elems_keep_top(c);
#else
		free_array(a);
#endif
	    }
	    return NULL;
	}
#ifndef ARRAY_USES_STACK
	else {
	    a = array_insert(a, &(Pike_sp[-1]), c);
	    pop_stack();
	}
#endif

	c++;
	fexec i;
    }

    myspace = [ \n\r\t];
    value_start = ["[{\-+.tfn] | digit;

    main := ('[' . myspace* . (
			      start: (
				']' -> final |
				value_start >parse_value . myspace* -> more
			      ),
			      more: (
				']' -> final |
				',' . myspace* -> start 
			      )
			     ) %*{ fbreak; }) ;
}%%

p_wchar2 *_parse_JSON_array(p_wchar2 *p, p_wchar2 *pe, struct parser_state *state) {
    p_wchar2 *i = p;
#ifndef ARRAY_USES_STACK
    struct array *a;
#endif
    int cs;
    int c = 0;

#ifndef ARRAY_USES_STACK
    if (!state->validate) {
	a = low_allocate_array(0,5);
    }
#endif

    %% write init;
    %% write exec;

    if (cs >= JSON_array_first_final) {
	if (!state->validate) {
#ifdef ARRAY_USES_STACK
	    f_aggregate(c);
#else
	    push_array(a);
#endif
	}
	return p;
    }

    if (!state->validate) {
#ifdef ARRAY_USES_STACK
	if (c > 0) {
	    pop_n_elems(c);
	}
#else
	free_array(a);
#endif
#ifdef JUMP
	Pike_error("Error parsing array at '%c'\n", (char)*p);
#endif
    }


    push_int((int)p);
    return NULL;
}
